#include "StdAfx.h"
#include "EventHandler.h"

CEventHandler::CEventHandler()
{
	m_uiMessageCount = MAX_MESSAGES;
	m_pMessages = NULL;
	m_uiLastUnusedMessage = 0;
}

CEventHandler::CEventHandler(UINT MaxMessages)
{
	m_uiMessageCount = MaxMessages;
	m_pMessages = NULL;
	m_uiLastUnusedMessage = 0;
}

CEventHandler::~CEventHandler()
{
	Destroy();
}

int CEventHandler::PostMessage(UINT uiMessage, DWORD lParam, DWORD wParam, UINT uiTimeoutMs)
{
	tMessage *NewMessage = NULL;
	UINT NewUnusedMessage = 0;


	for (UINT i=0; i<m_uiMessageCount; i++)
	{
		if(m_pMessages[i].bUsed == false && NewMessage != NULL)
		{
			m_uiLastUnusedMessage = i;
			break;
		}

		if(m_pMessages[i].bUsed == false && NewMessage == NULL)
			NewMessage = &m_pMessages[i];
	}

	if(NewMessage !=NULL)
	{
		
		NewMessage->uiMessage = uiMessage;
		NewMessage->dwTimeout = uiTimeoutMs;
		NewMessage->dwCreateTime = m_Timer.GetAbsoluteTime();
		NewMessage->dwParam[0] = lParam;
		NewMessage->dwParam[1] = wParam;
		NewMessage->bUsed = true;

		return 1;
	}

	return 0;
}

void CEventHandler::Dispatch(bool bOnce)
{
	
}

tMessage *CEventHandler::GetMessage(UINT uiIndex)
{
	if(uiIndex >=0 && uiIndex < m_uiMessageCount)
		return &m_pMessages[uiIndex];

	return NULL;
}

UINT CEventHandler::GetMessageCount()
{
	return m_uiMessageCount;
}

void CEventHandler::Flush()
{
	for (int i=0; i<m_uiMessageCount; i++)
		m_pMessages[i].bUsed = false;
}

void CEventHandler::Destroy()
{
	SAFEDEL_ARRAY(m_pMessages)
}
