#ifndef EVENTHANDLER_H
#define EVENTHANDLER_H

#include "Common.h"

#define MAX_MESSAGES 64

/*********** Message structure ************/
struct tMessage
{
	UINT 	uiMessage;
	DWORD 	dwParam[2];		// Various data passed using those
	double 	dwCreateTime;		// Time of creation of this message
	UINT 	dwTimeout;		// How long this message exists in a queue
	bool 	bUsed;

	tMessage()
	{
		uiMessage = dwTimeout = dwCreateTime = dwParam[0] = dwParam[1] = 0;
		bUsed = false;

#ifdef USE_GLOBAL_TIMER
		dwCreateTime = CGlobalTimer::GetSingleton().GetAbsoluteTime();
#endif
	};

	virtual ~tMessage()
	{

	};
};

class CEventHandler
{

public:
	CEventHandler();
	CEventHandler(UINT MaxMessages);
	virtual ~CEventHandler();

	virtual int PostMessage(UINT uiMessageIndex, DWORD Param1 = 0, DWORD Param2 = 0, UINT uiTimeoutMs = 0);
	tMessage* GetMessage(UINT uiMessageIndex);
	UINT GetMessageCount();

	virtual void Destroy();
	virtual void Dispatch(bool bOnce = true) = 0;
	virtual void Flush() = 0;

protected:

	tMessage *m_pMessages;
	UINT m_uiMessageCount;
	UINT m_uiLastUnusedMessage;

	CTimer m_Timer;
};

#endif