#include "FrameAnimation.h"

template<class TAnimation> CFrameAnimation<TAnimation>::CFrameAnimation()
{
	m_piDataIndex = NULL;
	m_pAnimationData = NULL;
	m_iFrameCount = 
		m_iLoopsCount = 
		m_iCurrentLoop = 
		m_iCurrentFrame = 
		m_iDataCount = 0;
	m_bLoop = false;
	m_bAnimationComplete = false;
	m_bPaused = false;
}

template<class TAnimation> CFrameAnimation<TAnimation>::~CFrameAnimation()
{
	Destroy();
}

template<class TAnimation> int CFrameAnimation<TAnimation>::Create(UINT FrameCount, UINT DataCount)
{
	if(FrameCount == 0 || DataCount == 0)
		return 0;

	m_iFrameCount = FrameCount;
	m_iDataCount = DataCount;

	m_pDataIndex = new int[m_iFrameCount];
	m_pAnimationData = new TAnimation[m_iDataCount];

	for (int i=0; i<m_iFrameCount ;i++)
		m_pDataIndex[i] = 0;

	for (int i=0; i<m_iDataCount; i++)
		m_pAnimationData[i] = NULL;

	return 1;
}

template<class TAnimation> int CFrameAnimation<TAnimation>::Animate(double TimePassed)
{
	if(!m_bPaused) // Do animation
	{

		double cur_time = m_Timer.GetAbsoluteTime();
		if(m_iCurrentFrame != (m_iFrameCount - 1))
		{
			if((cur_time - m_fLastTime) >= dt)
			{
				m_iCurrentFrame++;
				m_fLastTime = cur_time;
			}
		}
		else
		{
			if(m_bLoop)
			{
				if(m_iCurrentLoop != (m_iLoopsCount - 1))
				{
					m_iCurrentLoop++;
					m_bAnimationComplete = false;
				}
				else
					m_bAnimationComplete = true;
			}
			m_bAnimationComplete = true;
		}
		return m_bAnimationComplete;
	}
	else
		return 0;

	return 1;
}

template<class TAnimation> int CFrameAnimation<TAnimation>::Pause(double PauseTime)
{
	m_bPaused = true;
	return 1;
}

template<class TAnimation> int CFrameAnimation<TAnimation>::Resume(double TimeToWait)
{
	m_bPaused = false;
	return 1;
}

template<class TAnimation> int CFrameAnimation<TAnimation>::Stop()
{
	m_bPaused = true;
	m_fLastTime = 0;
	m_iCurrentFrame = 0;
	m_bAnimationComplete = false;
	m_iCurrentLoop = 0;

	return 1;
}

template<class TAnimation> int CFrameAnimation<TAnimation>::Load(TiXmlNode *DataNode, string Filename)
{

	return 1;
}

template<class TAnimation> int CFrameAnimation<TAnimation>::Save(TiXmlNode *DataNode, string Filename)
{

	return 1;
}

template<class TAnimation> void CFrameAnimation<TAnimation>::Destroy()
{
	if(m_piDataIndex)
	{
		delete[] m_piTexIndex;
		m_piTexIndex = NULL;

		m_iFrameCount = 0;
	}

	if(m_pAnimationData)
	{
		for (int i=0; i<m_iDataCount; i++)
			m_pAnimationData = NULL;

		delete[] m_pAnimationData;
		m_pAnimationData = NULL;

		m_iDataCount = 0;
	}
}
