// GUIEditApp.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "GUIEditor.h"

#include "MainFrm.h"
#include "ChildFrm.h"
#include "GUIEditorDoc.h"
#include "GUIEditorView.h"
#include <mmsystem.h>
#include ".\guieditor.h"
#pragma comment( lib, "winmm.lib" )

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGUIEditorApp

BEGIN_MESSAGE_MAP(CGUIEditorApp, CWinApp)
	//{{AFX_MSG_MAP(CGUIEditorApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	// NOTE - the ClassWizard will add and remove mapping macros here.
	//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard file based document commands
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	ON_COMMAND(ID_FILE_NEW, OnFileNew)
	ON_COMMAND(ID_FILE_SAVE, OnFileSave)
	ON_COMMAND(ID_MENU_FILE_SAVE, OnMenuFileSave)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGUIEditorApp construction

CGUIEditorApp::CGUIEditorApp()
{
	m_uiGUIUID = 0;
	m_lCurTime = 0;             
	m_dwTimeCount = 8;   
	m_lPerfCounter = 1;       
	m_bPerFlag = FALSE;    
	m_lNextTime = 0;    
	m_lLastTime = 0;	 
	m_dTimeElapsed = 0.0;	 
	m_dTimeScale = 0.0;		
	m_lFramesPerSecond = 90;
	m_pLastView = NULL;
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CGUIEditorApp object

CGUIEditorApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CGUIEditorApp initialization

BOOL CGUIEditorApp::InitInstance()
{
	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// Change the registry key under which our settings are stored.
	// TODO: You should modify this CString to be something appropriate
	// such as the name of your company or organization.
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));

	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CMultiDocTemplate* pDocTemplate;
	pDocTemplate = new CMultiDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CGUIEditorDoc),
		RUNTIME_CLASS(CChildFrame), // custom MDI child frame
		RUNTIME_CLASS(CGUIEditorView));
	AddDocTemplate(pDocTemplate);

	// create main MDI Frame window
	CMainFrame *pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	m_pMainWnd = pMainFrame;

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;

	// Change m_nShellCommand value to FileNothing
	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	// The main window has been initialized, so show and update it.
	pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();

	if(pMainFrame->MDIGetActive() !=NULL)
	{
		CGUIEditorView *pActiveView = (CGUIEditorView *)pMainFrame->MDIGetActive()->GetActiveView();
		if(pActiveView !=NULL)
		{
			pMainFrame->SetWindowPixelFormat(pActiveView->m_hDC);
			pMainFrame->CreateViewGLContext(pActiveView->m_hDC);
		}
	}
	
	LoadApp("application.xml");
	return TRUE;
}


int CGUIEditorApp::Run()
{
	if (!m_pMainWnd)
		AfxPostQuitMessage(0);

	MSG msg;
	CMainFrame* pFrame = (CMainFrame *)AfxGetMainWnd();

	if ( QueryPerformanceFrequency ( ( LARGE_INTEGER *) &m_lPerfCounter ) ) { 

		// yes, set m_dwTimeCount and timer choice flag 
		m_bPerFlag = TRUE;
		m_dwTimeCount = unsigned long(m_lPerfCounter / m_lFramesPerSecond);
		QueryPerformanceCounter ( ( LARGE_INTEGER * ) &m_lNextTime ); 
		m_dTimeScale = 1.0 / m_lPerfCounter;
	} else  { 
		// no performance counter, read in using timeGetTime 

		m_lNextTime = timeGetTime (); 
		m_dTimeScale = 0.001;
	} 
	// save time of last frame

	// Get the active MDI child window.
	CMDIChildWnd *pChild =	(CMDIChildWnd *) pFrame->GetActiveFrame();
	/* or CMDIChildWnd *pChild =
	pFrame->MDIGetActive();
	*/
	// Get the active view attached to the active MDI child window.
	CGUIEditorView *pView = (CGUIEditorView *) pChild->GetActiveView();

	m_lLastTime = m_lNextTime;

	while ( TRUE ) {
		//see if there is a message waiting

		pFrame = (CMainFrame *)AfxGetApp()->m_pMainWnd;
		// Get the active MDI child window.
		pChild =	(CMDIChildWnd *) pFrame->GetActiveFrame();
		/* or CMDIChildWnd *pChild =
		pFrame->MDIGetActive();
		*/
		// Get the active view attached to the active MDI child window.
		CGUIEditorView *pView = (CGUIEditorView *) pChild->GetActiveView();
		if(m_pLastView !=pView)
		{
			if(m_pLastView !=NULL)
				wglMakeCurrent(((CGUIEditorView *)m_pLastView)->m_hDC, NULL);

			m_pLastView = pView;
			if(pView !=NULL)
				wglMakeCurrent(pView->m_hDC, pFrame->m_hRC);
		}
		if ( ::PeekMessage ( &msg, NULL, 0, 0, PM_NOREMOVE ) ) { 
			do //if there is pump all waiting
			{
				if ( !PumpMessage () )
					return ExitInstance ();
			} while ( ::PeekMessage ( &msg, NULL, 0, 0, PM_NOREMOVE ) );
		} else {

			// use the appropriate method to get time 
			// and calculate elapsed time since last frame

			if ( m_bPerFlag ) {
				QueryPerformanceCounter ( ( LARGE_INTEGER * ) &m_lCurTime );	
			} else {
				m_lCurTime=timeGetTime (); 
			}

			// is it time to render the frame? 

			if ( m_lCurTime > m_lNextTime ) { 

				// calculate elapsed time

				m_dTimeElapsed = ( m_lCurTime - m_lLastTime ) * m_dTimeScale;


				// save frame time

				m_lLastTime = m_lCurTime;

				// yes, render the frame 

				if ( !pFrame->m_bAppIsActive )
					WaitMessage();
				else
				{
					if(pView !=NULL)
					{
						pView->RenderGLScene();

						if(CInputEngine::GetSingletonPtr() !=NULL)
						{
							CInputEngine::GetSingleton().Poll();

							CMouse *pMouse = CInputEngine::GetSingleton().GetMouse();
							tVERTEX2d MousePos = pMouse->GetCursorPos();

							POINT MP;	
							MP.x = MousePos.x;	
							MP.y = MousePos.y;
							pView->ScreenToClient(&MP);

#ifdef OPENGL
							int Viewport[4];
							glGetIntegerv(GL_VIEWPORT, Viewport);
							MP.y = Viewport[3] - MP.y;
#endif	

							pMouse->SetCursorPos(MP.x, MP.y);
						}
					}
					//	if(pFrame->m_wndManager.fps !=NULL)
					//	{
					//		progress+=1;
					//		pFrame->m_wndManager.fps->OnUpdate(progress);						
					//		}
				}

				// set time for next frame 

				m_lNextTime = m_lCurTime + m_dwTimeCount; 

			} // end if

		} // end if else

	} // end while
	return msg.wParam;

} 
/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

	// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

	// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
public:
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CGUIEditorApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

void CGUIEditorApp::LoadApp(CString strFilename)
{
	TiXmlDocument AppDoc;
	TiXmlNode *pAppNode = NULL;

	if(AppDoc.LoadFile(strFilename))
	{
		const char *pcValue = NULL;
		pAppNode = AppDoc.FirstChild();

		if(CTextureManager::GetSingletonPtr() !=NULL)
		{
			pcValue = pAppNode->ToElement()->Attribute("TextureDatabase");
			if(pcValue !=NULL)
			{
				CTextureManager::GetSingleton().LoadXML(NULL, pcValue);
				pcValue = NULL;
			}
		}

		if(CMaterialManager::GetSingletonPtr() !=NULL)
		{
			pcValue = pAppNode->ToElement()->Attribute("MaterialDatabase");
			if(pcValue !=NULL)
			{
				CMaterialManager::GetSingleton().LoadXML(NULL, pcValue);
				pcValue = NULL;
			}
		}

		if(CAnimationManager::GetSingletonPtr() !=NULL)
		{
			pcValue = pAppNode->ToElement()->Attribute("AnimationDatabase");
			if(pcValue !=NULL)
			{
				CAnimationManager::GetSingleton().LoadXML(NULL, pcValue);
				pcValue = NULL;
			}
		}

		if(CFontManager::GetSingletonPtr() !=NULL)
		{
			pcValue = pAppNode->ToElement()->Attribute("FontDatabase");
			if(pcValue !=NULL)
			{
				CFontManager::GetSingleton().LoadXML(NULL, pcValue);
				pcValue = NULL;
			}
		}

		POSITION posTemplate = GetFirstDocTemplatePosition();
		CDocTemplate * pTemplate = GetNextDocTemplate(posTemplate);

		TiXmlNode *pIterNode = pAppNode->FirstChild();
		while(pIterNode !=NULL)
		{
			CGUIEditorDoc *pNewDoc = (CGUIEditorDoc *)pTemplate->CreateNewDocument();
			pNewDoc->OnNewDocument();
			CMainFrame *pMainFrame = (CMainFrame *)AfxGetMainWnd();

			CChildFrame *pNewFrame = (CChildFrame *)pTemplate->CreateNewFrame(pNewDoc, pMainFrame);

			CView *pActiveView = (CView *)pNewFrame->GetDescendantWindow(AFX_IDW_PANE_FIRST, TRUE);
			pNewFrame->SetActiveView(pActiveView);

			if(pNewDoc->GetGUI() !=NULL)
				pNewDoc->GetGUI()->LoadXML(pIterNode, "");
			
			pNewFrame->SetWindowText(pNewDoc->GetGUI()->GetName());

			pIterNode = pAppNode->IterateChildren(pIterNode);
		}
	}

}

void CGUIEditorApp::OnFileSave()
{
	
}

void CGUIEditorApp::OnMenuFileSave()
{
	TiXmlDocument XMLAppDoc;
	TiXmlElement AppXMLElement("Application");

	CString AppPath = GetAppPath();

	AppXMLElement.SetAttribute("TextureDatabase", "texture_database.xml");
	CTextureManager::GetSingleton().SaveXML(NULL, AppPath + "texture_database.xml");

	AppXMLElement.SetAttribute("MaterialDatabase", "material_database.xml");
	CMaterialManager::GetSingleton().SaveXML(NULL, AppPath + "material_database.xml");

	AppXMLElement.SetAttribute("AnimationDatabase", "animation_database.xml");
	CAnimationManager::GetSingleton().SaveXML(NULL, AppPath + "animation_database.xml");

	AppXMLElement.SetAttribute("FontDatabase", "font_database.xml");
	CFontManager::GetSingleton().SaveXML(NULL, AppPath + "font_database.xml");

	POSITION posTemplate = GetFirstDocTemplatePosition();
	UINT uiCount = 0;
	while (posTemplate != 0)
	{
		CDocTemplate * pTemplate = GetNextDocTemplate(posTemplate);
		POSITION posDoc = pTemplate->GetFirstDocPosition();
		while (posDoc != 0)
		{
			CDocument *pDoc = pTemplate->GetNextDoc(posDoc);
			if (! pDoc->IsKindOf(RUNTIME_CLASS(CGUIEditorDoc)))
				continue;

			CGUIEditorDoc * pGUIDoc = reinterpret_cast<CGUIEditorDoc*>(pDoc);
			if(pGUIDoc->GetGUI() !=NULL)
			{
				if(uiCount !=0)
				{
					TiXmlElement GUIXMLElement("GUI");
					pGUIDoc->GetGUI()->SaveXML(&GUIXMLElement, "");
					AppXMLElement.InsertEndChild(GUIXMLElement);
				}
			}
			uiCount++;
		}
	}

	XMLAppDoc.InsertEndChild(AppXMLElement);
	XMLAppDoc.SaveFile(AppPath + "application.xml");
}
