#ifndef INPUTDEVICE_H
#define INPUTDEVICE_H

#pragma once
#include "Entity.h"
#include "InputDeviceState.h"

//! Input Device class
/*!
	This class provides an easy and clear interface for other devices to use.
	It features basic functionality for ANY device
*/
class CInputDevice : public CEntity
{
	CREATOR(CInputEngine);

protected:

	CInputDevice();
	virtual ~CInputDevice();
	/*!
		Method details:
		\return 1 if device has been created succesfully, 0 otherwise
	*/
	virtual int Create() = 0;
	/*!
		Method details:
		Destroys the device
	*/
	virtual void Destroy() = 0;
	/*!
		Method details:
		This is an implementation of Custom RTTI
	*/
	virtual bool IsOfType(eEntityType eType);
};

#endif