#include "StdAfx.h"
#include "InputDeviceState.h"

CInputDeviceState::CInputDeviceState()
{
	m_uipKeys = NULL;
	m_uiKeyCount = 0;
	
	#ifdef DIRECT_INPUT
		m_pDIDevice = NULL;
	#endif
}

CInputDeviceState::~CInputDeviceState()
{
	Destroy();
}

UINT CInputDeviceState::GetKeyState(UINT uiKeyIndex)
{
	if(m_uipKeys !=NULL)
	{
		if(uiKeyIndex >=0 && uiKeyIndex < m_uiKeyCount)
			return m_uipKeys[uiKeyIndex];
	}

	return 0;
}

UINT CInputDeviceState::GetKeyCount()
{
	return m_uiKeyCount;
}

bool CInputDeviceState::IsKeyDown(UINT uiKey)
{

	return false;
}

bool CInputDeviceState::IsKeyUp(UINT uiKey)
{

	return false;
}

void CInputDeviceState::SetKeyState(UINT uiKey, UINT uiState)
{
	if(uiKey >=0 && uiKey < 256)
		m_uipKeys[uiKey] = uiState;
}

void CInputDeviceState::Destroy()
{
	SAFEDEL(m_uipKeys)

	#ifdef DIRECT_INPUT
		if(m_pDIDevice !=NULL)
		{
			m_pDIDevice->Release();
			m_pDIDevice = NULL;
		}
	#endif
}