#include "StdAfx.h"
#include "Keyboard.h"

CKeyboard::CKeyboard()
{
	m_uipKeys = new UINT[256];
	m_uiKeyCount = 256;
}

CKeyboard::~CKeyboard()
{
	Destroy();
}

int CKeyboard::Create()
{
	#ifdef DIRECT_INPUT
		if(m_pDIDevice == NULL)
		{
			HRESULT Result = g_pDI->CreateDevice(GUID_SysKeyboard, &m_pDIDevice, NULL);
			if(FAILED(Result))
				return 0;


			m_pDIDevice->SetDataFormat( &c_dfDIKeyboard );
			return 1;
		}
	#endif

	return 1;
}

UINT CKeyboard::Poll()
{
	if(m_uipKeys == NULL)
		return 0;

	#ifndef DIRECT_INPUT
		ZeroMemory(m_uipKeys, sizeof(UINT) * 256);
		GetKeyboardState((BYTE *)m_uipKeys);
	#else
		if(m_pDIDevice !=NULL)
		{
			m_pDIDevice->Acquire();
			ZeroMemory(m_uipKeys, sizeof(UINT) * 256);

			HRESULT Result = m_pDIDevice->GetDeviceState(sizeof(UINT) * 256, &m_uipKeys);
		}
	#endif

	return 1;
}

UINT CKeyboard::GetKeyState(UINT uiKeyIndex)
{
	if(m_uipKeys !=NULL)
	{
		if(uiKeyIndex >=0 && uiKeyIndex < m_uiKeyCount)
			return m_uipKeys[uiKeyIndex];
	}

	return 0;
}

bool CKeyboard::IsKeyDown(char cKey)
{
	return (m_uipKeys[cKey] == KEY_DOWN);
}

bool CKeyboard::IsKeyUp(char cKey)
{
	return (m_uipKeys[cKey] == KEY_UP);
}

void CKeyboard::Destroy()
{

}

bool CKeyboard::IsOfType(eEntityType eType)
{
	if(eType == Entity_Keyboard)
		return true;

	return CEntity::IsOfType(eType);
}