#ifndef LOGICALFONT_H
#define LOGICALFONT_H

#pragma once
#include "CustomFont.h"

class CLogicalFont : public CCustomFont
{
	CREATOR(CFontManager);

protected:

	CLogicalFont();
	virtual ~CLogicalFont() {};

public:

	int CreateFont(HDC hDC, UINT Height, UINT Width, UINT EscapeAngle,
							 UINT OrientAngle, UINT Weight, unsigned long Italic,
							 unsigned long Underline, unsigned long Strikeout, 
							 unsigned long Charset, unsigned long OutputPrec, 
							 unsigned long ClipPrec, unsigned long OutputQual, 
							 unsigned long Family, unsigned long Pitch, 
							 CString FontName, UINT Letters);


	virtual int LoadXML(TiXmlNode *DataNode, CString Filename);
	virtual int SaveXML(TiXmlNode *DataNode, CString Filename);

	virtual void Destroy();

	//! Drawing function
	virtual void Draw(CString Format, ...) = 0;
	//! Draws a character
	virtual void DrawChar(float x, float y, char c) = 0;

protected:
	UINT m_uiFontWidth, m_uiFontHeight, m_uiEscapeAngle, m_uiOrientAngle, m_uiFontWeight;
	unsigned long m_ulItalic, m_ulUnderline, m_ulStrikeout, m_ulCharset, m_ulOutPrecis, m_ulClipPrecis, m_ulOQ;
	unsigned long m_ulFamily, m_ulPitch;

private:
	UINT		m_uiFontBase;
	UINT		m_uiNumLists;

	HFONT m_hFont, m_hOldFont;
};

#endif