#include "StdAfx.h"
#include "Mouse.h"

CMouse::CMouse()
{
	m_uipKeys = new UINT[8];
	m_uiKeyCount = 8;
}

CMouse::~CMouse()
{
	Destroy();
}

int CMouse::Create()
{
	#ifdef DIRECT_INPUT
		if(m_pDIDevice == NULL)
		{
			HRESULT Result = g_pDI->CreateDevice(GUID_SysMouse, &m_pDIDevice, NULL);
			if(FAILED(Result))
				return 0;

			m_pDIDevice->SetDataFormat( &c_dfDIMouse2 );
			return 1;
		}
	#endif

	return 1;
}

UINT CMouse::Poll()
{
	if(m_uipKeys == NULL)
		return 0;

	POINT Point;
	::GetCursorPos(&Point);
	ScreenToClient(GetActiveWindow(), &Point);

	m_PrevCursorPos = m_CursorPos;

	m_CursorPos.x = Point.x; 
	m_CursorPos.y = Point.y;

	#ifdef OPENGL
		int Viewport[4];
		glGetIntegerv(GL_VIEWPORT, Viewport);
		m_CursorPos.y = Viewport[3] - m_CursorPos.y;
	#endif

	#ifdef DIRECT_INPUT
		if(m_pDIDevice !=NULL)
		{
			m_pDIDevice->Acquire();
			ZeroMemory(&m_MouseState, sizeof(DIMOUSESTATE2));

			//HRESULT Result = m_pDIDevice->GetDeviceState(sizeof(DIMOUSESTATE2), &m_MouseState);

			//for (UINT i=0; i<m_uiKeyCount; i++)
			//	m_uipKeys[i] = m_MouseState.rgbButtons[i];
		}
	#endif

	return 1;
}

UINT CMouse::GetKeyState(UINT uiKeyIndex)
{
	if(m_uipKeys !=NULL)
		return m_uipKeys[uiKeyIndex];

	return 0;
}

void CMouse::SetCursorPos(int x, int y)
{
	m_CursorPos.x = x; m_CursorPos.y = y;
}

tVERTEX2d& CMouse::GetCursorPos()
{
	return m_CursorPos;
}

tVERTEX2d& CMouse::GetPrevCursorPos()
{
	return m_PrevCursorPos;
}

bool CMouse::IsButtonDown(UINT uiButtonIndex)
{
	return (GetKeyState(uiButtonIndex) == KEY_DOWN);
}

bool CMouse::IsButtonUp(UINT uiButtonIndex)
{
	if(GetKeyState(uiButtonIndex) == KEY_UP)
		return true;

	return false;
}

void CMouse::Destroy()
{

}

bool CMouse::IsOfType(eEntityType eType)
{
	if(eType == Entity_Mouse)
		return true;

	return CEntity::IsOfType(eType);
}