#include "MouseState.h"

CMouseState::CMouseState()
{
	#ifndef DIRECT_INPUT
		m_uipKeys = new UINT[5];
		m_uiKeyCount = 5;
	#else
		m_uipKeys = new UINT[8];
		m_uiKeyCount = 8;
	#endif
}

CMouseState::~CMouseState()
{
	Destroy();
}

UINT CMouseState::Poll()
{
	#ifndef DIRECT_INPUT
		POINT Point;
		::GetCursorPos(&Point);
		ScreenToClient(GetActiveWindow(), &Point);

		m_CursorPos.x = Point.x; 
		m_CursorPos.y = Point.y;

		m_uipKeys[(UINT)VK_LBUTTON] = GetAsyncKeyState(VK_LBUTTON);
		m_uipKeys[(UINT)VK_MBUTTON] = GetAsyncKeyState(VK_MBUTTON);
		m_uipKeys[(UINT)VK_RBUTTON] = GetAsyncKeyState(VK_RBUTTON);
	#else
		if(m_pDIDevice == NULL)
		{
			HRESULT Result = g_pDI->CreateDevice(GUID_SysMouse, &m_pDIDevice, NULL);
			if(FAILED(Result))
				return 0;

			m_pDIDevice->SetDataFormat( &c_dfDIMouse2 );
			return 1;
		}

		m_pDIDevice->Acquire();
		ZeroMemory(&m_MouseState, sizeof(DIMOUSESTATE2));

		HRESULT Result = m_pDIDevice->GetDeviceState(sizeof(DIMOUSESTATE2), &m_MouseState);

		for (UINT i=0; i<m_uiKeyCount; i++)
			m_uipKeys[i] = m_MouseState.rgbButtons[i];
	#endif

	return 1;
}

tVERTEX2d CMouseState::GetCursorPos()
{
	return m_CursorPos;
}


