#include "StdAfx.h"
#include "OpenGLMaterial.h"

COpenGLMaterial::COpenGLMaterial()
{
	SetEntityType(Entity_OpenGLMaterial);
}

COpenGLMaterial::~COpenGLMaterial()
{

}

int COpenGLMaterial::LoadXML(TiXmlNode *pDataNode, CString strFilename)
{
	return CMaterial::LoadXML(pDataNode, strFilename);
}

int COpenGLMaterial::SaveXML(TiXmlNode *pDataNode, CString strFilename)
{
	return CMaterial::SaveXML(pDataNode, strFilename);
}

void COpenGLMaterial::Bind()
{
	glEnable(GL_LIGHTING);
//	glDisable(GL_TEXTURE_2D);
	glMaterialfv( GL_FRONT, GL_AMBIENT,	 m_Ambient.RGBA	);
	glMaterialfv( GL_FRONT, GL_DIFFUSE,	 m_Diffuse.RGBA	);
	glMaterialfv( GL_FRONT, GL_SPECULAR, m_Specular.RGBA );
	glMaterialfv( GL_FRONT, GL_EMISSION, m_Emissive.RGBA );
	glMaterialf( GL_FRONT, GL_SHININESS, m_fShininess );
}

void COpenGLMaterial::Destroy()
{

}

bool COpenGLMaterial::IsOfType(eEntityType eType)
{
	if(eType == Entity_OpenGLMaterial)
		return true;

	return CXMLResource::IsOfType(eType);
}