#include "stdafx.h"
#include "ResourceManager.h"

CResourceManager::CResourceManager()
{
	SetEntityType(Entity_ResourceManager);
}

CResourceManager::~CResourceManager()
{
	Destroy();
}

int CResourceManager::LoadXML(TiXmlNode *pDataNode, CString strFilename)
{
	TiXmlElement* pXMLElement = NULL;
	const char *pcValue = NULL;

	int iRetValue = CXMLResource::LoadXML(pDataNode, strFilename);	// LoadXML the data of derivative
	if(iRetValue !=1)
		return iRetValue;
		
	pXMLElement = m_pXMLElement;
	
	return 1;
}

int CResourceManager::SaveXML(TiXmlNode *pDataNode, CString strFilename)
{
	
	return 0;
}

CXMLResource *CResourceManager::AddResource(CString strName, UINT uiID, eEntityType ResourceType)
{
	
	return NULL;
}

CXMLResource *CResourceManager::GetResource(int uiIndex, int uiID, CString strName, CString strFilename)
{
	if(uiID !=-1 && uiIndex == -1 && strName == "" && strFilename == "")	// get by uiID
	{
		CXMLResource *ResourcePtr = begin();
		set_ptr(ResourcePtr);

		while(ResourcePtr !=NULL)
		{
			if(ResourcePtr->GetID() == uiID)
				return (CXMLResource *)ResourcePtr;

			ResourcePtr = next();
		}
	}
	else if(strName !="" && uiIndex == -1 && uiID == -1 && strFilename == "")	// get by name
	{
		CXMLResource *ResourcePtr = begin();
		set_ptr(ResourcePtr);

		while(ResourcePtr !=NULL)
		{
			if(ResourcePtr->GetName() == strName)
				return (CXMLResource *)ResourcePtr;

			ResourcePtr = next();
		}
	}
	else if(uiIndex !=-1 && uiID == -1 && strName == "" && strFilename == "")	// get by index
	{
		if(uiIndex >=0 && uiIndex < size())
			return (CXMLResource *)at(uiIndex);
	}
	else if(strFilename !="" && uiID == -1 && strName == "" && uiIndex == -1)
	{
		CXMLResource *ResourcePtr = begin();
		set_ptr(ResourcePtr);

		while(ResourcePtr !=NULL)
		{
			if(ResourcePtr->GetFilename() == strFilename)
				return (CXMLResource *)ResourcePtr;

			ResourcePtr = next();
		}
	}

	return NULL;
}

int CResourceManager::RemoveResource(CXMLResource *pResource)
{
	
	return 1;
}

void CResourceManager::Destroy()
{
	while(size() !=0)
	{
		CXMLResource *pResource = pop_back();
		SAFEDEL(pResource)
	}

	CXMLResource::Destroy();
}

bool CResourceManager::IsOfType(eEntityType eType)
{
	if(eType == Entity_ResourceManager)
		return true;

	return CXMLResource::IsOfType(eType);
}