#include "stdafx.h"
#include "XMLResource.h"

CXMLResource::CXMLResource()
{
	SetEntityType(Entity_XMLResource);
	m_pXMLElement = NULL;
}

CXMLResource::~CXMLResource()
{
	Destroy();
}

void CXMLResource::SetFilename(CString strFilename)
{
	m_strFilename = strFilename;
}

CString CXMLResource::GetFilename()
{
	return m_strFilename;
}

int CXMLResource::LoadXML(TiXmlNode *pDataNode, CString strFilename)
{
	if(pDataNode == NULL && strFilename == "")	// If both parameters are invalid, return error
		return -1;

	const char *pcValue = NULL;
	TiXmlElement* pXMLElement = NULL;
	TiXmlNode *XMLNode = NULL;
	TiXmlDocument XMLDoc;

	if(strFilename !="")
	{
		if(strFilename.Find(CString(".xml")) > 0)
		{
			if(!XMLDoc.LoadFile(strFilename.GetBuffer()))
				return false;
			else
			{
				XMLNode = XMLDoc.FirstChild();
				m_strFilename = strFilename;
			}
		}
		else
			return 1;
	}
	else
		XMLNode = pDataNode;
	
	if(XMLNode !=NULL)
	{
		pcValue = XMLNode->ToElement()->Attribute("Filename");
		if(pcValue !=NULL)
		{
			m_strFilename = CString(pcValue);
			LoadXML(NULL, m_strFilename);
		}
	}

	if(m_pXMLElement !=NULL)
		SAFEDEL(m_pXMLElement)

	if(XMLNode !=NULL)
		m_pXMLElement = XMLNode->Clone()->ToElement();
	else
		m_pXMLElement = pDataNode->Clone()->ToElement();

	pcValue = m_pXMLElement->Attribute("Name");
	if(pcValue !=NULL)
	{
		SetName(CString(pcValue));
		pcValue = NULL;
	}

	pcValue = m_pXMLElement->Attribute("ID");
	if(pcValue !=NULL)
	{
		SetID((UINT)atoi(pcValue));
		pcValue = NULL;
	}

	return 1;
}

int CXMLResource::SaveXML(TiXmlNode *pDataNode, CString strFilename)
{

	return 0;
}

void CXMLResource::Destroy()
{
	if(m_pXMLElement !=NULL)
	{
		m_pXMLElement->Clear();
		SAFEDEL(m_pXMLElement)
	}
}

bool CXMLResource::IsOfType(eEntityType eType)
{
	if(eType == Entity_XMLResource)
		return true;

	return CResource::IsOfType(eType);
}